    #include <stdio.h>
    #include <mpi.h>  

    #define SIMPLE_SPRNG
    #define USE_MPI		
    #include <sprng.h>

    #define SEED 985456376

    main(int argc, char *argv[])
    {
        double rn;
        int i, myid;
        int gtype;  

        MPI_Init(&argc, &argv);       /* Initialize MPI */
        MPI_Comm_rank(MPI_COMM_WORLD, &myid);	/* find process id */ 

        if(myid == 0)
        {
            printf("Type in an integer for the generator type:  ");
            scanf("%d", &gtype);
        }
        MPI_Bcast(&gtype,1,MPI_INT,0,MPI_COMM_WORLD ); /*--- broadcast gen type */
                                                      
        init_sprng(gtype,SEED,SPRNG_DEFAULT);	/* initialize stream  */
        printf("Process %d, print information about stream:\n", myid);
        print_sprng();

        for (i=0;i<3;i++)
        {
            rn = sprng();		/* generate double precision random number */
            printf("Process %d, random number %d: %.14f\n", myid, i+1, rn);
        }

        MPI_Finalize();		/* Terminate MPI  */
    }
 
